import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Difracao2 extends PApplet {

PFont fonte1, fonte2, fonte3, fonte4, fonte5, fonte6, fonte7;
PImage atomo, start, forw, lambda, theta, ret, constr, destr, bragg, back;
float mouse_x, mouse_y, t0 = 0, time, t1 = 0, t2 = 0, t3 = 0, t4 = 0, t5 = 0, t6 = 0, t, x_sin, y_sin, amplitude = 24, angle_sin, prevX, prevY, numOfWaves = 11, amplitude2, numOfWaves2 = 18, next = 0;
int count, passe1 = 0, count2, interf = 1, window = 0, sub_w = 1;
boolean play = false, passe2 = false, passe3 = false, passe4 = false, passe5 = false, passe6 = false;

public void setup() {
 size(800, 600);
 background(255);
 fonte1 = loadFont("Corbel-BoldItalic-36.vlw");
 fonte2 = loadFont("Corbel-30.vlw");
 fonte3 = loadFont("Corbel-Bold-20.vlw");
 fonte4 = loadFont("Calibri-20.vlw");
 fonte5 = loadFont("Calibri-16.vlw");
 fonte6 = loadFont("Calibri-14.vlw");
 fonte7 = loadFont("Calibri-12.vlw");
 atomo = loadImage("sphere.png");
 start = loadImage("play.png");
 forw = loadImage("forw.png");
 lambda = loadImage("lambda.png");
 theta = loadImage("theta.gif");
 ret = loadImage("return.png");
 constr = loadImage("const.png");
 destr = loadImage("dest.png");
 bragg = loadImage("bragg.png");
 back = loadImage("back.png");

}
public void draw() {
   background(255);
   textFont(fonte1);
   fill(0);
   smooth();
   time = millis();
   textAlign(CENTER);
   text("Difra\u00e7\u00e3o de Raios-X", 400, 40);
   textFont(fonte2);
   text("Lei de Bragg", 400, 80);
   if(interf == 1) {
     fill(204, 0, 0);
     stroke(204, 0, 0);
   }
   else {
     fill(255, 121, 121);
     stroke(255, 121, 121);
   }
   rect(290, 110, 100, 25);
   if(interf == 2) {
     fill(204, 0, 0);
     stroke(204, 0, 0);
   }
   else {
     fill(240, 94, 94);
     stroke(240, 94, 94);
   }
   rect(410, 110, 100, 25);
   fill(255);
   textFont(fonte3);
   text("M\u00e1ximos", 290, 113, 100, 25);
   text("M\u00ednimos", 410, 113, 100, 25);
   noFill();
   if(play == false) {
     image(start, 430, 515, 32, 32);
     fill(0);
     textFont(fonte2);
     text("Iniciar", 378, 540);
   }
   fill(0);
    
  //translate aqui para aumentar o espa\u00e7o para texto
  pushMatrix();
  translate(0, -50);  
  //primeiro plano
  image(atomo, 70, 300, 30, 30);
  image(atomo, 227.5f, 300, 30, 30);
  image(atomo, 385, 300, 30, 30);
  image(atomo, 542.5f, 300, 30, 30);
  image(atomo, 700, 300, 30, 30);
  //segundo plano
  image(atomo, 70, 470, 30, 30);
  image(atomo, 227.5f, 470, 30, 30);
  image(atomo, 385, 470, 30, 30);
  image(atomo, 542.5f, 470, 30, 30);
  image(atomo, 700, 470, 30, 30);
  
  smooth();
  if(passe2 == false)
    noStroke();
  else
    stroke(255, 218, 5);
  strokeWeight(2);
  pushMatrix();
  translate(400, 470 + amplitude/2);
  scale(1, -1);
  rotate(radians(36));
 //onda que atinge o segundo plano
  for(count=0; count < 605 && play == true && interf == 1; ++count) {
    x_sin = count;
 
    angle_sin = radians(count);
    y_sin = sin(angle_sin*(numOfWaves/0.8f));
 
    y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
    
    if(count >= -1*(time - t0 - 604*20)/20 && t0 != 0 && passe2 == false) {
      stroke(255, 218, 5);
      if(count == 0) {
        passe2 = true;
        if(t3 == 0)
          t3 = millis();
      }
    }
    
    
    if(count <= (t - t2 - 3000)/50 && t2 != 0 && count <= 26 && passe1 > 0)
      stroke(255, 0, 0);
    if(count <= (t - t2 - 6000)/50 && t2 != 0 && count > 26 && count <= 52 && passe1 > 1)
      stroke(255, 0, 0);
    if(count <= (t - t2 - 9000)/50 && t2 != 0 && count > 52 && count <= 78 && passe1 > 2)
      stroke(255, 0, 0);
    if(count <= (t - t2 - 12000)/50 && t2 != 0 && count > 78 && count <= 104 && passe1 > 3)
      stroke(255, 0, 0);
    
    line(prevX, prevY, x_sin, y_sin);
    if(passe2 == true)
      stroke(255, 218, 5);
    prevX = x_sin;
    prevY = y_sin;
  }
 
  prevX = prevY = 0.0f;
  
  popMatrix();
  //numera\u00e7\u00e3o das ondas
  if(interf == 1) {
    if(t - t0 >= 1500 && t0 != 0) {
      text("1", 785, 66);
      text("2", 785, 180);
    }
    if(passe2 == true && passe3 == true) {
      text("1'", 380, 270);
      text("2'", 376, 438);
    }
  }
  else {
    if(t - t0 >= 1500 && t0 != 0) {
      text("3", 785, 178);
      text("4", 785, 332);
    }
    if(passe2 == true && passe3 == true) {
      text("3'", 380, 273);
      text("4'", 376, 438);
    }
  }
  //onda que atinge o primeiro plano
  pushMatrix();
  translate(400, 300 + amplitude/2);
  scale(1, -1);
  rotate(radians(36));
  if(passe2 == false)
    noStroke();
  else
    stroke(255, 218, 5);
  for(int count=0; count < 500 && play == true && interf == 1; ++count) {
    x_sin = count;
 
    angle_sin = radians(count);
    y_sin = sin(angle_sin*(numOfWaves/0.8f));
 
    y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
    
    if(count >= -1*(time - t0 - 499*20)/20 && t0 != 0 && passe2 == false) {
      stroke(255, 218, 5);
      if(count == 0) {
        passe3 = true;
        if(t4 == 0)
          t4 = millis();
      }
    }
 
    line(prevX, prevY, x_sin, y_sin);
    
    prevX = x_sin;
    prevY = y_sin;
  }
 
  prevX = prevY = 0.0f;
  
  popMatrix();
  if(play == true && interf == 1) {
    
    if(next == 0) {
      textFont(fonte5);
      text("O raios-X que incidem no cristal s\u00e3o paralelos e est\u00e3o em fase. O \u00e2ngulo de incid\u00eancia \u00e9 de 54\u00b0. O raio 1 incide no primeiro plano at\u00f4mico do cristal, enquanto o raio 2 incide no segundo plano at\u00f4mico. Dessa forma, o caminho percorrido pelos dois raios-X \u00e9 diferente: o raio 2 percorre o trajeto mais longo. ", 30, 530, 740, 100);
      if(passe4 == true && passe5 == true) {
        image(forw, 740, 600, 32, 32);
        textFont(fonte4);
        text("Continuar", 694, 622); 
      }
    }
    else if(next == 1) {
      textFont(fonte6);
      text("Os m\u00e1ximos de difra\u00e7\u00e3o - decorrentes da interfer\u00eancia construtiva dos raios-X - acontecem para \u00e2ngulos de incid\u00eancia tais que a diferen\u00e7a de percurso dos dois raios-X corresponda a um n\u00famero inteiro de comprimentos de onda. Observe que a diferen\u00e7a de percurso dos raios incidentes \u00e9 delimitada pela reta pontilhada partindo do ponto de incid\u00eancia do raio 1, com dire\u00e7\u00e3o perpendicular \u00e0 dire\u00e7\u00e3o de propaga\u00e7\u00e3o dos raios-X incidentes. Um a um, os comprimentos de onda contidos nesta diferen\u00e7a de percurso s\u00e3o destacados em vermelho.", 20, 530, 760, 250);
      if(passe1 == 5) {
        image(forw, 740, 610, 32, 32);
        textFont(fonte4);
        text("Continuar", 694, 632);
      }
    }
    else if(next == 2) {
      textFont(fonte6);
      text("Para delimitar a diferen\u00e7a de percurso dos raios difratados, procede-se da mesma forma que com os raios incidentes. Tra\u00e7a-se uma reta pontilhada partindo do \u00e1tomo de incid\u00eancia do raio 1, perpendicularmente \u00e0 dire\u00e7\u00e3o de propaga\u00e7\u00e3o dos raios-X difratados. Os comprimentos de onda contidos na diferen\u00e7a de percurso s\u00e3o contados e destacados em vermelho. Como voc\u00ea pode verificar ao fim da anima\u00e7\u00e3o, s\u00e3o 8 os comprimentos de onda contidos na diferen\u00e7a total de percurso. Portanto, h\u00e1 interfer\u00eancia construtiva e o \u00e2ngulo de incid\u00eancia de 54\u00b0 configura um m\u00e1ximo de difra\u00e7\u00e3o. Observe que isto acontece porque, a partir da linha pontilhada, os raios difratados 1' e 2' deixam o cristal em fase.", 15, 515, 770, 200);
      if(passe1 == 10) {
        image(ret, 740, 615, 24, 24);
        textFont(fonte4);
        text("Reiniciar", 694, 632);
      }
    }
    t = millis();
    if(t1 == 0 && next == 1)
      t1 = millis();
    if(t - t1 > 3000 && t1 != 0) {
      if(passe6 == false) {
        stroke(0);
        fill(0);
        dottedLine(400, 315, 484, 421, 21);
        dottedLine(400, 315, 361, 344, 8);
     
        //mouse_x = mouseX;
        //mouse_y = mouseY;
        //println(mouse_y);
        
        stroke(0);
        strokeWeight(1);
        line(385, 325, 396, 340);
        line(396, 340, 411, 329);
      }
      if(t2 == 0)
        t2 = millis();
    }
    if(t - t2 > 3000 && t2 != 0 && passe1 == 0) {
      passe1 = 1;
    }
    else if(t - t2 > 5600 && passe1 == 1 && t2 != 0)
      passe1 = 2;
    else if(t - t2 > 9000 && passe1 == 2 && t2 != 0)
      passe1 = 3;
    else if(t - t2 > 13500 && passe1 == 3 && t2 != 0)
      passe1 = 4;
    else if(t - t2 > 17600 && passe1 == 4 && t2 != 0)
      passe1 = 5;

    if(passe1 == 2) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("1", 453, 497);
      fill(0);
      text("       x ", 453, 497);
      image(lambda, 473, 480, 18, 18);
    }
    else if(passe1 == 3) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("2", 453, 497);
      fill(0);
      text("       x ", 453, 497);
      image(lambda, 473, 480, 18, 18);
    }
     else if(passe1 == 4) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("3", 453, 497);
      fill(0);
      text("       x ", 453, 497);
      image(lambda, 473, 480, 18, 18);
    }
     else if(passe1 == 5 || passe1 == 6) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("4", 453, 497);
      fill(0);
      text("       x ", 453, 497);
      image(lambda, 473, 480, 18, 18);
    }
    if(passe2 == true) { //difra\u00e7\u00e3o das ondas
      if(passe4 == false)
        noStroke();
      else
        stroke(255, 218, 5);
      strokeWeight(2);
      pushMatrix();
      translate(400, 470 + amplitude/2);
      scale(1, -1);
      rotate(radians(144));
     //onda do segundo plano
      for(count=0; count < 605 && play == true && interf == 1; ++count) {
        x_sin = count;
     
        angle_sin = radians(count);
        y_sin = sin(angle_sin*(numOfWaves/0.8f));
     
        y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
        
        if(count <= (time - t3)/20 && t3 != 0 && passe4 == false) {
          stroke(255, 218, 5);
          if(count == 604)
            passe4 = true;
        }
        
        if(count <= (t - t6 - 3000)/50 && t6 != 0 && count <= 27 && passe1 > 5)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 6000)/50 && t6 != 0 && count > 27 && count <= 53 && passe1 > 6)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 9000)/50 && t6 != 0 && count > 53 && count <= 79 && passe1 > 7)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 12000)/50 && t6 != 0 && count > 79 && count <= 105 && passe1 > 8)
          stroke(255, 0, 0);
        
        line(prevX, prevY, x_sin, y_sin);
        if(passe4 == true)
          stroke(255, 218, 5);
        else
          noStroke();
        prevX = x_sin;
        prevY = y_sin;
      }
     
      prevX = prevY = 0.0f;
      
      popMatrix();
    }
    if(passe3 == true) {  
      //onda do primeiro plano
      pushMatrix();
      translate(400, 300 + amplitude/2);
      scale(1, -1);
      rotate(radians(144));
      if(passe5 == false)
        noStroke();
      else
        stroke(255, 218, 5);
      for(int count=0; count < 500 && play == true && interf == 1; ++count) {
        x_sin = count;
     
        angle_sin = radians(count);
        y_sin = sin(angle_sin*(numOfWaves/0.8f));
     
        y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
        
        if(count <= (time - t4)/20 && t4 != 0 && passe4 == false) {
          stroke(255, 218, 5);
          if(count == 499)
            passe5 = true;
        }
        
        line(prevX, prevY, x_sin, y_sin);
        
        prevX = x_sin;
        prevY = y_sin;
        if(passe5 == false)
          noStroke();
        else
          stroke(255, 218, 5);
      }
     
      prevX = prevY = 0.0f;
      
      popMatrix();
       
    }
    if(passe4 == true && passe1 >= 5) {
      if(passe6 == true) {
        stroke(0);
        fill(0);
        dottedLine(401, 314, 315, 420, 21);
        dottedLine(401, 314, 442, 346, 8);
     
        //mouse_x = mouseX;
        //mouse_y = mouseY;
        //println(mouse_x);
        
        stroke(0);
        strokeWeight(1);
        line(388, 329, 403, 340);
        line(403, 340, 415, 325);
        if(t6 == 0)
          t6 = millis();
        else if(t - t6 > 3000 && passe1 == 5 && t6 != 0)
          passe1 = 6;
        else if(t - t6 > 5600 && passe1 == 6 && t6 != 0)
          passe1 = 7;
        else if(t - t6 > 9000 && passe1 == 7 && t6 != 0)
          passe1 = 8;
        else if(t - t6 > 13500 && passe1 == 8 && t6 != 0) 
          passe1 = 9;
        else if(t - t6 > 17600 && passe1 == 9 && t6 != 0) 
          passe1 = 10;
    
        if(passe1 == 7) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("5", 290, 497);
          fill(0);
          text("       x ", 290, 497);
          image(lambda, 310, 480, 18, 18);
        }
        else if(passe1 == 8) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("6", 290, 497);
          fill(0);
          text("       x ", 290, 497);
          image(lambda, 310, 480, 18, 18);
        }
         else if(passe1 == 9) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("7", 290, 497);
          fill(0);
          text("       x ", 290, 497);
          image(lambda, 310, 480, 18, 18);
        }
         else if(passe1 == 10) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("8", 290, 497);
          fill(0);
          text("       x ", 290, 497);
          image(lambda, 310, 480, 18, 18);
        }
      }   
    }

  }
  //final do inter = 1
  else if(play == true && interf == 2) {
    //onda que atinge o segundo plano

    if(passe2 == false)
      noStroke();
    else
      stroke(255, 218, 5);
    pushMatrix();
    translate(378, 468 + amplitude/2);
    scale(1, -1);
    rotate(radians(16));
    for(count=0; count < 556 && play == true && interf == 2; ++count) {
      x_sin = count;
   
      angle_sin = radians(count);
      y_sin = sin(angle_sin*(numOfWaves/0.8f));
   
      y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
      
      if(count >= -1*(time - t0 - 555*20)/20 && t0 != 0 && passe2 == false) {
        stroke(255, 218, 5);
        if(count == 19) {
          passe2 = true;
          if(t3 == 0)
            t3 = millis();
        }
      } 
      
      
      if(count <= (t - t2 - 3000)/50 && t2 != 0 && count <= 26 && passe1 > 0)
        stroke(255, 0, 0);
      if(count <= (t - t2 - 6000)/50 && t2 != 0 && count > 26 && count <= 52 && passe1 > 1)
        stroke(255, 0, 0);
      if(count <= (t - t2 - 9000)/50 && t2 != 0 && count > 52 && count <= 78 && passe1 > 2)
        stroke(255, 0, 0);
       
      if(count < 19)
        noStroke();
      line(prevX, prevY, x_sin, y_sin);
      if(passe2 == true && count >= 19)
        stroke(255, 218, 5);
    
      prevX = x_sin;
      prevY = y_sin;
    }
   
    prevX = prevY = 0.0f;
    
    popMatrix();
    //onda que atinge o primeiro plano
    pushMatrix();
    //translate(378, 298 + amplitude/2);
    translate(400, 300 + amplitude/2);
    scale(1, -1);
    rotate(radians(16));
    if(passe2 == false)
      noStroke();
    else
      stroke(255, 218, 5);
    for(int count=0; count < 502 && play == true && interf == 2; ++count) {
      x_sin = count;
   
      angle_sin = radians(count);
      y_sin = sin(angle_sin*(numOfWaves/0.8f));
   
      y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
      
      if(count >= -1*(time - t0 - 501*20)/20 && t0 != 0 && passe2 == false) {
        stroke(255, 218, 5);
        if(count == 0) { //antes era 19
          passe3 = true;
          if(t4 == 0)
            t4 = millis();
        }
      }
      //if(count < 19)
        //noStroke();
   
      line(prevX, prevY, x_sin, y_sin);
      
      if(passe2 == true /*&& count >= 19*/)
        stroke(255, 218, 5);
      prevX = x_sin;
      prevY = y_sin;
    }
   
    prevX = prevY = 0.0f;
    
    popMatrix();  
    
    
    //come\u00e7a aqui
    time = millis();
    if(next == 0) {
      textFont(fonte5);
      text("O raios-X 3 e 4 s\u00e3o paralelos e incidem no cristal em fase. O \u00e2ngulo de incid\u00eancia \u00e9 de 16\u00b0. O raio 3 incide no primeiro plano at\u00f4mico do cristal e o raio 4, no segundo plano at\u00f4mico. Assim, os raios-X percorrem caminhos de comprimentos diferentes. O raio 4 percorre o caminho mais longo.", 30, 530, 740, 100);
      if(passe4 == true && passe5 == true) {
        image(forw, 740, 600, 32, 32);
        textFont(fonte4);
        text("Continuar", 694, 622); 
      }
    }
    else if(next == 1) {
      textFont(fonte6);
      text("Os m\u00ednimos de difra\u00e7\u00e3o s\u00e3o resultado da interfer\u00eancia totalmente destrutiva, que acontece quando a diferen\u00e7a de percurso entre os raios-X corresponde a um n\u00famero inteiro de comprimentos de onda mais meio. A diferen\u00e7a de percurso dos raios incidentes \u00e9 delimitada pela reta pontilhada partindo do ponto de incid\u00eancia do raio 3, com dire\u00e7\u00e3o perpendicular \u00e0 dire\u00e7\u00e3o de propaga\u00e7\u00e3o do feixe incidente. Observe a contagem dos comprimentos de onda contidos na diferen\u00e7a de caminho dos raios incidentes, destacados em vermelho.", 20, 530, 760, 250);
      if(passe1 == 4) {
        image(forw, 740, 610, 32, 32);
        textFont(fonte4);
        text("Continuar", 694, 632);
      }
    }
    else if(next == 2) {
      textFont(fonte6);
      text("Para delimitar a diferen\u00e7a de percurso dos raios difratados, tra\u00e7a-se uma reta pontilhada partindo do \u00e1tomo de incid\u00eancia do raio 3, perpendicularmente \u00e0 dire\u00e7\u00e3o de propaga\u00e7\u00e3o do feixe difratado. Note que os comprimentos de onda contidos na diferen\u00e7a de percurso s\u00e3o contados e destacados em vermelho. Como voc\u00ea pode verificar ao fim da anima\u00e7\u00e3o, s\u00e3o 4 1/2 os comprimentos de onda contidos na diferen\u00e7a de caminho total. Consequentemente, h\u00e1 interfer\u00eancia destrutiva e o \u00e2ngulo de incid\u00eancia de 16\u00b0 configura um m\u00ednimo de difra\u00e7\u00e3o. Observe que, a partir da linha pontilhada, os raios difratados est\u00e3o em oposi\u00e7\u00e3o de fase.", 15, 515, 770, 200);
      if(passe1 == 8) {
        image(ret, 740, 615, 24, 24);
        textFont(fonte4);
        text("Reiniciar", 694, 632);
      }
    }
    t = millis();
    if(t1 == 0 && next == 1)
      t1 = millis();
    if(t - t1 > 3000 && t1 != 0) {
      if(passe6 == false) {
        stroke(0);
        fill(0);
        dottedLine(400, 315, 452, 460, 21);
        dottedLine(400, 315, 350, 330, 8);
        
        stroke(0);
        strokeWeight(1);
        line(381, 319, 388, 340);
        line(388, 340, 407, 334);
      }
      if(t2 == 0)
        t2 = millis();
    }
    if(t - t2 > 3000 && t2 != 0 && passe1 == 0) {
      passe1 = 1;
    }
    else if(t - t2 > 5600 && passe1 == 1 && t2 != 0)
      passe1 = 2;
    else if(t - t2 > 9000 && passe1 == 2 && t2 != 0)
      passe1 = 3;
    else if(t - t2 > 13500 && passe1 == 3 && t2 != 0)
      passe1 = 4;

    if(passe1 == 2) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("1/4", 453, 497);
      fill(0);
      text("               x ", 453, 497);
      image(lambda, 498, 480, 18, 18);
    }
    else if(passe1 == 3) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("1 1/4", 453, 497);
      fill(0);
      text("               x ", 453, 497);
      image(lambda, 498, 480, 18, 18);
    }
     else if(passe1 == 4 || passe1 == 5) {
      fill(255, 0, 0);
      textFont(fonte4);
      text("2 1/4", 453, 497);
      fill(0);
      text("               x ", 453, 497);
      image(lambda, 498, 480, 18, 18);
    }
    
    if(passe2 == true) { //difra\u00e7\u00e3o das ondas
      if(passe4 == false)
        noStroke();
      else
        stroke(255, 218, 5);
      strokeWeight(2);
      pushMatrix();
      
      translate(409, 464 + amplitude/2);
      scale(1, -1);
      rotate(radians(164));
     //onda do segundo plano
     
      for(count=0; count < 575 && play == true && interf == 2; ++count) {
        x_sin = count;
     
        angle_sin = radians(count);
        y_sin = sin(angle_sin*(numOfWaves/0.8f));
     
        y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
        
        if(count <= (time - t3)/20 && t3 != 0 && passe4 == false) {
          stroke(255, 218, 5);
          if(count == 574)
            passe4 = true;
        }
        
        if(count <= (t - t6 - 3000)/50 && t6 != 0 && count <= 13 && passe1 > 4)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 6000)/50 && t6 != 0 && count > 13 && count <= 39 && passe1 > 5)
          stroke(255, 0, 0);
        if(count <= (t - t6 - 9000)/50 && t6 != 0 && count > 39 && count <= 65 && passe1 > 6)
          stroke(255, 0, 0);

        
        if(count < 8)
          noStroke();
        line(prevX, prevY, x_sin, y_sin);
        if(passe4 == true && count >= 8)
          stroke(255, 218, 5);
        else if(passe4 == false)
          noStroke();
        
        prevX = x_sin;
        prevY = y_sin;
      }
     
      prevX = prevY = 0.0f;
      
      popMatrix();
    }
    if(passe3 == true) {  
      //onda do primeiro plano
      pushMatrix();
      //translate(409, 294 + amplitude/2);
      translate(400, 300 + amplitude/2);
      scale(1, -1);
      rotate(radians(164));
      if(passe5 == false)
        noStroke();
      else
        stroke(255, 218, 5);
      for(int count=0; count < 470 && play == true && interf == 2; ++count) {
        x_sin = count;
     
        angle_sin = radians(count);
        y_sin = sin(angle_sin*(numOfWaves/0.8f));
     
        y_sin = map(y_sin,-1,1,-amplitude/2,amplitude/2);
        
        if(count <= (time - t4)/20 && t4 != 0 && passe4 == false) {
          stroke(255, 218, 5);
          if(count == 469)
            passe5 = true;
        }
        line(prevX, prevY, x_sin, y_sin);
        if(passe4 == true)
          stroke(255, 218, 5);
        else if(passe4 == false)
          noStroke();
        
        prevX = x_sin;
        prevY = y_sin;
        if(passe5 == false)
          noStroke();
        else
          stroke(255, 218, 5);
      }
     
      prevX = prevY = 0.0f;
      
      popMatrix();
       
    }
    if(passe4 == true && passe1 >= 4) {
      if(passe6 == true) {
        stroke(0);
        fill(0);
        dottedLine(401, 314, 348, 458, 21); //arrumar aqui
        dottedLine(401, 314, 449, 331, 8);
     
        //mouse_x = mouseX;
        //mouse_y = mouseY;
        //println(mouse_y);
        
        stroke(0);
        strokeWeight(1);
        line(393, 334, 413, 340); //arrumar aqui
        line(413, 340, 419, 321);
        if(t6 == 0)
          t6 = millis();
        else if(t - t6 > 3000 && passe1 == 4 && t6 != 0)
          passe1 = 5;
        else if(t - t6 > 5600 && passe1 == 5 && t6 != 0)
          passe1 = 6;
        else if(t - t6 > 9000 && passe1 == 6 && t6 != 0)
          passe1 = 7;
        else if(t - t6 > 13500 && passe1 == 7 && t6 != 0) 
          passe1 = 8;
    
        if(passe1 == 6) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("2 1/2", 297, 497);
          fill(0);
          text("               x ", 297, 497);
          image(lambda, 347, 480, 18, 18);
        }
        else if(passe1 == 7) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("3 1/2", 297, 497);
          fill(0);
          text("               x ", 297, 497);
          image(lambda, 347, 480, 18, 18);
        }
         else if(passe1 == 8) {
          fill(255, 0, 0);
          textFont(fonte4);
          text("4 1/2", 297, 497);
          fill(0);
          text("               x ", 297, 497);
          image(lambda, 347, 480, 18, 18);
        }
      }   
    }
  
  }
  //final do if play == true
  
  popMatrix(); //fim do translate
  if(window == 0) {
    strokeJoin(BEVEL);
    strokeWeight(4);
    stroke(204, 0, 0);
    fill(204, 0, 0);
    rect(40, 35, 140, 30);
    rect(40, 85, 140, 30);
    rect(620, 35, 140, 30);
    rect(620, 85, 140, 30);
    fill(255);
    textFont(fonte3);
    textAlign(CENTER);
    text("Cr\u00e9ditos", 40, 40, 140, 30);
    text("Processing", 40, 90, 140, 30);
    text("Introdu\u00e7\u00e3o", 620, 40, 140, 30);
    text("Refer\u00eancias", 620, 90, 140, 30);
    textAlign(LEFT);
  }
  else if(window == 1) {
    background(255);
    fill(8, 21, 95);
    textFont(fonte1);
    textAlign(LEFT);
    text("Introdu\u00e7\u00e3o", 50, 45);
    fill(0);
    textAlign(CENTER);
    image(ret, 714, 20);
    textFont(fonte4);
    text("Retornar \u00e0 anima\u00e7\u00e3o", 610, 40); 
    if(sub_w == 1) {
      textFont(fonte6);
      text("A difra\u00e7\u00e3o de raios-X \u00e9 amplamente empregada em Ci\u00eancia e Engenharia de Materiais. O padr\u00e3o de difra\u00e7\u00e3o de feixes de raios-X incidentes em v\u00e1rios \u00e2ngulos sobre um determinado cristal fornece in\u00fameras informa\u00e7\u00f5es acerca do seu arranjo at\u00f4mico ou molecular. \nA " +
      "difra\u00e7\u00e3o ocorre quando um feixe de ondas encontra uma s\u00e9rie de obst\u00e1culos regularmente espa\u00e7ados, capazes de espalh\u00e1-lo, e de magnitude compar\u00e1vel \u00e0 do comprimento de onda do feixe. As ondas incidentes est\u00e3o inicialmente em fase, por pertencerem todas ao mesmo feixe; no entanto, por percorrerem caminhos diferentes para atravessar os obst\u00e1culos, essas ondas deixam o cristal com uma rela\u00e7\u00e3o de fases dependente do \u00e2ngulo de incid\u00eancia e do " +
      "comprimento dos obst\u00e1culos.\nA rela\u00e7\u00e3o de fases das ondas difratadas apresenta dois casos extremos: os m\u00e1ximos de difra\u00e7\u00e3o, para os quais ocorre interfer\u00eancia totalmente construtiva, e os m\u00ednimos de difra\u00e7\u00e3o, para os quais a interfer\u00eancia \u00e9 totalmente destrutiva. A interfer\u00eancia construtiva est\u00e1 ilustrada na Figura 1. Nessa figura, voc\u00ea pode notar que, ap\u00f3s o " +
      "espalhamento, as ondas permanecem em fase e se somam, resultando em uma onda com o dobro de amplitude. A condi\u00e7\u00e3o necess\u00e1ria para que isso aconte\u00e7a \u00e9 que a diferen\u00e7a de percurso das duas ondas contenha um n\u00famero inteiro de comprimentos de onda.", 50, 80, 700, 400);
      image(constr, 175, 345, 450, 225);
      text("Figura 1: Interfer\u00eancia construtiva.", 400, 337);
      textFont(fonte7);
      text("Extra\u00edda de 'Materials Science and Engineering: An Introduction, 8th edition, William D. Callister e David G. Rethwisch (modificada).", 180, 567, 440, 100);
      image(forw, 714, 550);
    }
    else if(sub_w == 2) {
      textFont(fonte6);
      text("A interfer\u00eancia destrutiva est\u00e1 ilustrada na Figura 2. Ap\u00f3s o espalhamento, as ondas deixam os obst\u00e1culos em oposi\u00e7\u00e3o de fase e, assim, se anulam. Isso acontece quando a diferen\u00e7a de percurso das ondas equivale a (n + \u00bd) x      , sendo n um n\u00famero inteiro e       o " +
      "comprimento de onda.\nUma condi\u00e7\u00e3o necess\u00e1ria, por\u00e9m insuficiente para a difra\u00e7\u00e3o de raios-X \u00e9 a Lei de Bragg, que define para que \u00e2ngulos de incid\u00eancia ocorrem os m\u00e1ximos de difra\u00e7\u00e3o:\n\n2 x d x sen      = n x      ,\n\nem que d \u00e9 a dist\u00e2ncia interplanar,      o " +
      "complemento do \u00e2ngulo de incid\u00eancia, n a ordem do m\u00e1ximo de difra\u00e7\u00e3o e       o comprimento de onda, como ilustrado na Figura 3.", 50, 80, 700, 400);
      image(lambda, 641, 100, 12, 12);
      image(lambda, 375, 117, 12, 12);
      image(theta, 398, 189, 12, 12);
      image(lambda, 441, 188, 12, 12);
      image(theta, 264, 225, 12, 12);
      image(lambda, 709, 224, 12, 12);
      image(destr, 20, 330, 390, 184);
      image(bragg, 430, 330, 350, 184);
      text("Figura 2: Interfer\u00eancia destrutiva.", 215, 310);
      text("Figura 3: Lei de Bragg.", 605, 310);
      textFont(fonte7);
      text("Figuras extra\u00eddas de 'Materials Science and Engineering: An Introduction, 8th edition, William D. Callister e David G. Rethwisch (modificadas).", 400, 540);
      image(forw, 714, 550);
      image(back, 54, 550);
    }
    else if(sub_w == 3) {
      textFont(fonte4);
      text("O objetivo desta anima\u00e7\u00e3o \u00e9 fornecer uma abordagem mais qualitativa e visual da Lei de Bragg do que a proporcionada pela equa\u00e7\u00e3o, relevando que para que os m\u00e1ximos de difra\u00e7\u00e3o ocorram , a diferen\u00e7a de percurso dos raios-X (de valor 2 x d x sen    ) deve conter um " +
      "n\u00famero inteiro de comprimentos de onda (n x     ) \u2013 como voc\u00ea pode verificar assistindo \u00e0 anima\u00e7\u00e3o com o bot\u00e3o \u2018M\u00e1ximos\u2019 ativado. Complementando o entendimento dos m\u00e1ximos de difra\u00e7\u00e3o, os m\u00ednimos de difra\u00e7\u00e3o acontecem quando a diferen\u00e7a de percurso entre os raios-X " +
      "equivale a um n\u00famero inteiro de comprimentos de onda mais meio comprimento de onda. Para verificar esse fato, mantenha o bot\u00e3o \u2018M\u00ednimos\u2019 ativado e assista \u00e0 anima\u00e7\u00e3o.", 80, 150, 640, 400);
      image(back, 54, 550);
      image(theta, 353, 232, 20, 20);
      image(lambda, 337, 259, 18, 18);
    }
  }
  else if (window == 2) {
    background(255);
    fill(8, 21, 95);
    textFont(fonte1);
    textAlign(LEFT);
    text("Refer\u00eancias", 50, 45);
    fill(0);
    textAlign(CENTER);
    image(ret, 714, 20);
    textFont(fonte4);
    text("Retornar \u00e0 anima\u00e7\u00e3o", 610, 40);
    textFont(fonte6);
    text("CALLISTER, William D.; RETHWISCH, David G. Materials science and engineering: an introduction. 8a. ed. Nova York: John Wiley and Sons, 2009. pp. 74-77.\n\n" +
    "Universidade Federal do Rio Grande do Sul - UFRGS. 'Cap\u00edtulo 5 - Raios-X'. F\u00edsica Moderna. http://www.webliminal.com/search/search-web13.html\nAcesso em 16 fev. 2013" +
    "\n\nAZEVEDO Jr., Walter F. 'Difra\u00e7\u00e3o de raios-X'. http://azevedolab.dominiotemporario.com/doc/diffraction1.pdf\nAcesso em 16 fev. 2013\n\n" +
    "Laborat\u00f3rio de Material Did\u00e1tico Multim\u00eddia - CETEC-MG. 'Cap\u00edtulo 04 - \u00cdndices Cristalogr\u00e1ficos e Difra\u00e7\u00e3o de Raios-X'. Ci\u00eancia dos Materiais Multim\u00eddia. http://www.cienciadosmateriais.org/index.php?acao=exibir&cap=9&top=104\nAcesso em 16 fev. 2013", 40, 90, 720, 400);
    fill(255, 0 , 0);
    text("Refer\u00eancias de imagens/\u00edcones", 400, 375);
    fill(0);
    text("\n\nhttp://www.iconlooker.com/icon/axialis-axialis-round-web2-red-png-player-play_w714.html. Acesso em 3 fev. 2013\n\nhttp://www.iconesbr.net/down_ico/7888/symbol_forward_2. Acesso em 8 fev. 2013\n\n" +
    "http://wallpaperdojo.com/3Dwallpapers/Wallpaperdojo_3D_Spheres_Wallpaper_Black_White_20/3Dwallpapers-wallpapers.html. Acesso em 10 set. 2012\n\nhttp://www.iconesbr.net/down_ico/6980/setas. Acesso em 28 jan. 2013", 40, 375, 720, 300);
    image(start, 12, 410, 16, 16);
    image(forw, 12, 444, 20, 20);
    image(atomo, 12, 479, 18, 18);
    image(ret, 12, 535, 18, 18);
  }
  else if(window == 3) {
    background(255);
    fill(8, 21, 95);
    textFont(fonte1);
    textAlign(LEFT);
    text("Cr\u00e9ditos", 50, 45);
    fill(0);
    textAlign(CENTER);
    image(ret, 714, 20);
    textFont(fonte4);
    text("Retornar \u00e0 anima\u00e7\u00e3o", 610, 40);
    text("Desenvolvimento: Luana Ianara Rubini Ruiz (Aluna do 3\u00ba ano do Curso de Engenharia El\u00e9trica - Sistemas Eletr\u00f4nicos, Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)\nOrienta\u00e7\u00e3o: Ivette Frida Cymbaum Oppenheim (Departamento de Engenharia Metal\u00fargica e de Materiais, Escola Polit\u00e9cnica da Universidade de S\u00e3o Paulo, S\u00e3o Paulo - SP, Brasil)\nTexto: Luana Ianara Rubini Ruiz e Ivette Frida Cymbaum Oppenheim\nCriado em: Processing                    \u00daltima atualiza\u00e7\u00e3o: 21/fevereiro/2013", 60, 118, 680, 420);
    text("\nApoio: A anima\u00e7\u00e3o 'Difra\u00e7\u00e3o de Raios-X - Lei de Bragg' foi desenvolvida no contexto do projeto 'Anima\u00e7\u00f5es para disciplinas Introdut\u00f3rias de Ci\u00eancia e Engenharia dos Materiais', integrante do 'Programa Ensinar com Pesquisa' da Pr\u00f3-Reitoria de Gradua\u00e7\u00e3o da Universidade de S\u00e3o Paulo, \u00e0 qual expressamos nossos agradecimentos pela concess\u00e3o da bolsa de Inicia\u00e7\u00e3o Cient\u00edfica (Projeto 5767 - ano 2012).", 60, 350, 680, 420);  
  }
  else if(window == 4) {
    background(255);
    fill(8, 21, 95);
    textFont(fonte1);
    textAlign(LEFT);
    text("Sobre o Processing", 50, 45);
    fill(0);
    textAlign(CENTER);
    image(ret, 714, 20);
    textFont(fonte4);
    text("Retornar \u00e0 anima\u00e7\u00e3o", 610, 40);
    text("'Processing' \u00e9 uma linguagem de programa\u00e7\u00e3o e ambiente de desenvolvimento com foco principal nas artes visuais, aproveitando-se da plataforma Java e de uma comunidade virtual intensamente atuante por meio do compartilhamento de c\u00f3digos e bibliotecas atrav\u00e9s da Internet. Surgiu como iniciativa de Casey Reas e Ben Fry, pesquisadores do Instituto de Tecnologia de Massachussets (MIT) dos E.U.A, sendo, desde sua cria\u00e7\u00e3o em 2001, disponibilizado gratuitamente como software livre, acess\u00edvel a qualquer interessado a partir do download no site \u2018processing.org', onde podem ser encontradas informa\u00e7\u00f5es adicionais sobre 'Processing'.", 120, 160, 560, 410);
  }
}

//http://processing.org/discourse/beta/num_1219255354.html
public void dottedLine(float x1, float y1, float x2, float y2, float steps){
 for(int i=0; i<=steps; i++) {
   float x = lerp(x1, x2, i/steps);
   float y = lerp(y1, y2, i/steps);
   noStroke();
   ellipse(x, y,2,2);
 }
}
public void mousePressed(){
  float ics, igrec;
  ics = mouseX;
  igrec = mouseY;
  if(window == 0) {
    if(ics >= 620 && ics <= 760 && igrec >= 35 && igrec <= 65) { 
      window = 1;
      sub_w = 1;
      igrec = 1000;
      ics = 1000;
    }
    if(ics >= 620 && ics <= 760 && igrec >= 85 && igrec <= 115) { 
      window = 2;
      igrec = 1000;
      ics = 1000; 
    }
    if(ics >= 40 && ics <= 180 && igrec >= 35 && igrec <= 65) { 
      window = 3;
      igrec = 1000;
      ics = 1000; 
    }
    if(ics >= 40 && ics <= 180 && igrec >= 85 && igrec <= 115) { 
      window = 4;
      igrec = 1000;
      ics = 1000; 
    }
    
    if(interf == 2 && ics >= 290 && ics <= 390 && igrec >= 110 && igrec <= 135) {
      ics = 1000;
      igrec = 1000;
      interf = 1;
      
      //reiniciando
      passe1 = 0;
      passe2 = false;
      passe3 = false;
      passe4 = false;
      passe5 = false;
      passe6 = false;
      t0 = millis();
      t1 = 0;
      t2 = 0;
      t3 = 0;
      t4 = 0;
      t5 = 0;
      t6 = 0;
      next = 0; 
    }
    else if(interf == 1 && ics >= 410 && ics <= 510 && igrec >= 110 && igrec <= 135) {
      ics = 1000;
      igrec = 1000;
      interf = 2;
      
      //reiniciando
      passe1 = 0;
      passe2 = false;
      passe3 = false;
      passe4 = false;
      passe5 = false;
      passe6 = false;
      t0 = millis();
      t1 = 0;
      t2 = 0;
      t3 = 0;
      t4 = 0;
      t5 = 0;
      t6 = 0;
      next = 0; 
    }
    if(play == true && ((passe1 == 10 && interf == 1) || (interf == 2 && passe1 == 8)) && ics >= 740 && ics <= 764 && igrec >= 565 && igrec <= 589) {
      //reiniciando
      passe1 = 0;
      passe2 = false;
      passe3 = false;
      passe4 = false;
      passe5 = false;
      passe6 = false;
      t0 = millis();
      t1 = 0;
      t2 = 0;
      t3 = 0;
      t4 = 0;
      t5 = 0;
      t6 = 0;
      next = 0;
    }
    if(play == false && ics >= 430 && ics <= 462 && igrec >= 515 && igrec <= 547) {
     play = true;
     t0 = millis();
     ics = 1000;
     igrec = 1000;
    }
    
    if(play == true && next == 0 && passe4 == true && passe5 == true && ics >= 740 && ics <= 772 && igrec >= 550 && igrec <= 582) {
      next = 1;
      ics = 1000;
      igrec = 1000;
    }
    if(play == true && next == 1 && ics >= 740 && ics <= 772 && igrec >= 560 && igrec <= 592 && passe6 == false) {
      passe6 = true;
      next = 2;
      ics = 1000;
      igrec = 1000;
    }
  }
  else if(window == 1) {
    if(ics >= 714 && ics <= 746 && igrec >= 20 && igrec <= 52) {
      window = 0;
      ics = 1000;
      igrec = 1000;
    }
    if(sub_w == 1 && ics >= 714 && ics <= 746 && igrec >= 550 && igrec <= 582) {
      sub_w = 2;
      ics = 1000;
      igrec = 1000;
    }
    else  if(sub_w == 2 && ics >= 714 && ics <= 746 && igrec >= 550 && igrec <= 582) {
      sub_w = 3;
      ics = 1000;
      igrec = 1000;
    }
    else  if(sub_w == 2 && ics >= 54 && ics <= 86 && igrec >= 550 && igrec <= 582) {
      sub_w = 1;
      ics = 1000;
      igrec = 1000;
    }
     else  if(sub_w == 3 && ics >= 54 && ics <= 86 && igrec >= 550 && igrec <= 582) {
      sub_w = 2;
      ics = 1000;
      igrec = 1000;
    }
  }
  else if(window == 2) {
     if(ics >= 714 && ics <= 746 && igrec >= 20 && igrec <= 52) {
      window = 0;
      ics = 1000;
      igrec = 1000;
    }
  }
   else if(window == 3) {
     if(ics >= 714 && ics <= 746 && igrec >= 20 && igrec <= 52) {
      window = 0;
      ics = 1000;
      igrec = 1000;
    }
  }
   else if(window == 4) {
     if(ics >= 714 && ics <= 746 && igrec >= 20 && igrec <= 52) {
      window = 0;
      ics = 1000;
      igrec = 1000;
    }
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Difracao2" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
